//"ekspFK.sci","Eksport do FK - include","\Eksport\Eksport include\",0,2.0.0,SYSTEM
/////////////////////////////////////////
// "Eksport do FK - include"
// ekspFK.sci
/////////////////////////////////////////

#define DANE_Z_ODDZIALU 1
#define XanulALL 0

#define lenMIASTO	40 //ograniczenie dugosci miasta kh incydentalnego

//Sprzeda

Dispatch xDekretacjeSp=xFactory.NewObject("BDekretacjeSp")
Dispatch xDekretParamsSp=xFactory.NewObject("BDekretParams")

//Zakup
Dispatch xDokumentZkKoryg
Dispatch xDekretacjeZk=xFactory.NewObject("BDekretacjeZk")
Dispatch xDekretParamsZk=xFactory.NewObject("BDekretParams")

//Patnoci
Dispatch xRapPnMan=xFactory.NewObject("BRapPn")

//Raporty okresowe
Dispatch xRapOkrMan=xFactory.NewObject("BRapOkr")
Dispatch xKartParamsDokSp = xFactory.NewObject("BKartParamsDokSp")

Dispatch xDekretacjeRapPn=xFactory.NewObject("BDekretacjeRapPn")
Dispatch xDekretParamsPn=xFactory.NewObject("BDekretParams")

//Wszystkie dokumenty
Dispatch xDekretacjeMg=xFactory.NewObject("BDekretacjeMg")
Dispatch xDekretParamsMg=xFactory.NewObject("BDekretParams")


#include "Eksport INFO - include"
#include "Eksport definicje - include"
#include "Eksport kontrahentw - include"
#include "Eksport pracownikw - include"
#include "Eksport urzdw - include"
#include "Eksport towarw - include"
#include "Auto eksport"
#include "Eksport DK - include"
#include "Eksport ZK - include"
#include "Eksport MG - include"
#include "Eksport PN - include"
#include "Eksport RO - include"

int iNieEkspOznak, iOznaczaj, iRownoKsiegMag, iDokumentZbiorczy, iDekretyZbiorcze, iRaportZbiorczy

int DECLARE PrintError(String msg)

int Sub EksportujDkDoCen(Dispatch xDokumentSp)
	EksportujDkDoCen = 1
	Dispatch xDokMg
	Dispatch xDokumentMg
	Dispatch xDokSp

	int iVal, err
	String tak = "TAK"
	if (tak != io.GetField("__CzyPytac")) then
		nBrakSchematu = EKSP_WSZYSTKIE
		nEZatwWart = EKSP_WSZYSTKIE
		nBlednySchemat = EKSP_WSZYSTKIE
		nEKontrZrealiz = EKSP_WSZYSTKIE
		
	endif

	int iOpcje = 0
	int nRes, ii

	long idDK
	idDK = xDokumentSp.id

	if (xDokumentSp.czyZaimportArch) then
		EksportujDkDoCen = 0 // pomijamy
		eksport.AddError("Nie mona wyeksportowa dokumentu " + xDokumentSp.numer + ". Dokument zosta zaimportowany z archiwum.")
		Exit // nie eksportujemy 
	endif

	if ( iNieEkspOznak && xDokumentSp.czyWyeksportFK ) then
		EksportujDkDoCen = 0 // pomijamy
		eksport.AddError("Nie mona powtrnie wyeksportowa dokumentu " + xDokumentSp.numer + ".")
		Exit // nie eksportujemy oznakowanych dokumentw
	endif

	// czy rwnolege ksigowanie magazynowe
	if ( iRownoKsiegMag ) then iOpcje |= ROWNOLEGLE_KSIEG_MAG

	if ( iNieEkspOznak ) then iOpcje |= NIE_EKSP_OZNAK

	TabRejVat.ClearRec()
	if !EksportDKbyDisp(xDokumentSp, iOpcje) then
		EksportujDkDoCen = 0 // pomijamy
		Exit
	endif

	/////////////////////////////////////////////////
	// oznaczamy wyeksportowane dokumenty
	if ( iOznaczaj ) then
		nRes = !(xDokSp=GetObjById("BDokSp",idDK))

		if nRes then PrintError(Using "Brak w bazie DK rekordu o id= %d", idDK)

		xDokSp.SetEkspFK()
		// dokumenty magazynowe rozliczajce dokument handlowy
		if ( iRownoKsiegMag ) then
			if ( !xDokumentSp.czyKorekta )then
				xDokumentSp.transakcjaTw.powiazaniaTw.PokazujIstniejace()
				for ii=1 to ii>xDokumentSp.transakcjaTw.powiazaniaTw.count
					// !!! sprawdzic jak sie wysyla nie zatwierdzone wartosciowo
					nRes =!( xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"

					if (xDokumentMg.czyWystawiony) then


						nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
						if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")

						xDokMg.SetEkspFK()
					endif
				next ii
			endif				
			for ii=1 to ii>xDokumentSp.zwiazkiOdpDok.Count()
				if ((xDokumentSp.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentSp.zwiazkiOdpDok.item(ii).idDk) then
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.zwiazkiOdpDok.item(ii).idDk))
					if nRes then  error "Dokument nie zaadowany"
					if (xDokumentMg.czyWystawiony) then


						nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
						if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")

						xDokMg.SetEkspFK()
					endif
				endif
			next ii
		endif
	endif
EndSub

int Sub EksportujDkDoFk(Dispatch xDokumentSp)
	EksportujDkDoFk = 1
	Dispatch xDokMg
	Dispatch xDokumentMg
	Dispatch xDokSp

	int iVal, err
	String tak = "TAK"
	if (tak != io.GetField("__CzyPytac")) then
		nBrakSchematu = EKSP_WSZYSTKIE
		nEZatwWart = EKSP_WSZYSTKIE
		nBlednySchemat = EKSP_WSZYSTKIE
		nEKontrZrealiz = EKSP_WSZYSTKIE
		
	endif

	int iOpcje = 0
	int nRes, ii

	long idDK
	idDK = xDokumentSp.id

	if (xDokumentSp.czyZaimportArch) then
		EksportujDkDoFk = 0 // pomijamy
		eksport.AddError("Nie mona wyeksportowa dokumentu " + xDokumentSp.numer + ". Dokument zosta zaimportowany z archiwum.")
		Exit // nie eksportujemy 
	endif

	if ( iNieEkspOznak && xDokumentSp.czyWyeksportFK ) then
		EksportujDkDoFk = 0 // pomijamy
		eksport.AddError("Nie mona powtrnie wyeksportowa dokumentu " + xDokumentSp.numer + ".")
		Exit // nie eksportujemy oznakowanych dokumentw
	endif

	// sprawdzamy czy zawarty w ro
	if(xDokumentSp.IdPeriodicSaleReport != 0) then
		EksportujDkDoFk = 0 // pomijamy
		eksport.AddInfo("Nie mona wyeksportowa dokumentu " + xDokumentSp.numer + ". Dokument jest zawarty w raporcie okresowym.")
		Exit // nie eksportujemy oznakowanych dokumentw
	endif	

	// czy rwnolege ksigowanie magazynowe
	if ( iRownoKsiegMag ) then iOpcje |= ROWNOLEGLE_KSIEG_MAG

	if ( iNieEkspOznak ) then iOpcje |= NIE_EKSP_OZNAK

	TabRejVat.ClearRec()
	if !EksportDKbyDisp(xDokumentSp, iOpcje) then
		EksportujDkDoFk = 0 // pomijamy
		Exit
	endif

	/////////////////////////////////////////////////
	// oznaczamy wyeksportowane dokumenty
	if ( iOznaczaj ) then
		nRes = !(xDokSp=GetObjById("BDokSp",idDK))

		if nRes then PrintError(Using "Brak w bazie DK rekordu o id= %d", idDK)

		xDokSp.SetEkspFK()
		// dokumenty magazynowe rozliczajce dokument handlowy
		if ( iRownoKsiegMag ) then
			if ( !xDokumentSp.czyKorekta )then
				xDokumentSp.transakcjaTw.powiazaniaTw.PokazujIstniejace()
				for ii=1 to ii>xDokumentSp.transakcjaTw.powiazaniaTw.count
					// !!! sprawdzic jak sie wysyla nie zatwierdzone wartosciowo
					nRes =!( xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"

					if (xDokumentMg.czyWystawiony) then


						nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
						if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")

						xDokMg.SetEkspFK()
					endif
				next ii
			endif				
			for ii=1 to ii>xDokumentSp.zwiazkiOdpDok.Count()
				if ((xDokumentSp.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentSp.zwiazkiOdpDok.item(ii).idDk) then
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.zwiazkiOdpDok.item(ii).idDk))
					if nRes then  error "Dokument nie zaadowany"
					if (xDokumentMg.czyWystawiony) then


						nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
						if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")

						xDokMg.SetEkspFK()
					endif
				endif
			next ii
		endif
	endif
EndSub

int Sub EksportujZkDoFk(Dispatch xDokumentZk)

	Dispatch xDokMg
	Dispatch xDokumentMg
	Dispatch xDokZk

	EksportujZkDoFk = 1
	String tak = "TAK"
	if (tak != io.GetField("__CzyPytac")) then
		nBrakSchematu = EKSP_WSZYSTKIE
		nEZatwWart = EKSP_WSZYSTKIE
		nBlednySchemat = EKSP_WSZYSTKIE
	endif

	int iVal, err, nRes, ii
	long idDK
	int iOpcje = 0

	idDK = eksport.GetId()

	nRes = !(xDokumentZk=GetObjById("BDokumentZk",idDK))

	if nRes then PrintError("Brak takiego rekordu w bazie DK")

	if ( iNieEkspOznak && xDokumentZk.czyWyeksportFK ) then
		EksportujZkDoFk = 0 // pomijamy
		eksport.AddError("Nie mona powtrnie wyeksportowa dokumentu " + xDokumentZk.numer + ".")
		Exit // nie eksportujemy oznakowanych dokumentw
	endif

	// czy rwnolege ksigowanie magazynowe
	if ( iRownoKsiegMag ) then iOpcje |= ROWNOLEGLE_KSIEG_MAG

	if ( iNieEkspOznak ) then iOpcje |= NIE_EKSP_OZNAK

	TabRejVat.ClearRec()
	if !EksportZKbyDisp(xDokumentZk, iOpcje) then
		EksportujZkDoFk = 0 // pomijamy
		Exit
	endif

	/////////////////////////////////////////////////
	// oznaczamy wyeksportowany dokument
	if ( iOznaczaj ) then

		nRes = !(xDokZk=GetObjById("BDokZk",idDK))

		if nRes then PrintError("Brak takiego rekordu w bazie DK")

		xDokZk.SetEkspFK()

		// dokumenty magazynowe rozliczajce dokument handlowy
		if ( iRownoKsiegMag ) then
			if ( !xDokumentZk.czyKorekta )then
				xDokumentZk.transakcjaTw.powiazaniaTw.PokazujIstniejace()
				for ii=1 to ii>xDokumentZk.transakcjaTw.powiazaniaTw.count()
					// !!! sprawdzic jak sie wysyla nie zatwierdzone wartosciowo
					nRes = !(xDokumentMg=GetObjById("BDokumentMg",xDokumentZk.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"

					if (xDokumentMg.czyWystawiony) then

						nRes = !(xDokMg=GetObjById("BDokMg",xDokumentMG.id))
						if nRes then PrintError("Dokument nie zaadowany")

						xDokMg.SetEkspFK()
					endif
				next ii
			endif
			for ii=1 to ii>xDokumentZk.zwiazkiOdpDok.Count()
				if ((xDokumentZk.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentZk.zwiazkiOdpDok.item(ii).idDk) then
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentZk.zwiazkiOdpDok.item(ii).idDk))
					if nRes then  error "Dokument nie zaadowany"
					if (xDokumentMg.czyWystawiony) then

						nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
						if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")

						xDokMg.SetEkspFK()
					endif
				endif
			next ii
		endif
	endif
EndSub

int Sub EksportujMgDoFk(Dispatch xDokumentMg)
	EksportujMgDoFk = 1

	Dispatch xDokMg

	String tak = "TAK"
	if (tak != io.GetField("__CzyPytac")) then
		nBrakSchematu = EKSP_WSZYSTKIE
		nEZatwWart = EKSP_WSZYSTKIE
		nBlednySchemat = EKSP_WSZYSTKIE
	endif

	int iOpcje = 0
	int nRes

	if ( iNieEkspOznak && xDokumentMg.czyWyeksportFK ) then
		EksportujMgDoFk = 0 // pomijamy
		eksport.AddError("Nie mona powtrnie wyeksportowa dokumentu " + xDokumentMg.numer + ".")
		Exit // nie eksportujemy oznakowanych dokumentw
	endif

	if iDokumentZbiorczy then
		// czy dekrety zbiorcze
		if ( iDekretyZbiorcze ) then iOpcje |= DEKRETY_ZBIORCZE

		if !EksportMG_zb_do_byDisp(xDokumentMg, iOpcje) then
			EksportujMgDoFk = 0 // pomijamy
			Exit
		endif
	else
		if !EksportMGbyDisp(xDokumentMg) then
			EksportujMgDoFk = 0 // pomijamy
			Exit
		endif
	endif

	/////////////////////////////////////////////////
	// oznaczamy wyeksportowany dokument
	if ( iOznaczaj ) then
		nRes = !(xDokMg=GetObjById("BDokMg",xDokumentMg.id))
		if nRes then PrintError("Brak takiego rekordu w bazie DK")

		xDokMg.SetEkspFK()
	endif
EndSub

int Sub EksportujPnDoFk(Dispatch xRapPn)
	EksportujPnDoFk = 1

	String tak = "TAK"
	if (tak != io.GetField("__CzyPytac")) then
		nBrakSchematu = EKSP_WSZYSTKIE
		nEZatwWart = EKSP_WSZYSTKIE
		nBlednySchemat = EKSP_WSZYSTKIE
	endif

	if ( iNieEkspOznak && xRapPn.czyWyekspFK ) then
		EksportujPnDoFk = 0 // pomijamy
		eksport.AddError("Nie mona powtrnie wyeksportowa raportu " + xRapPn.numer + ".")
		Exit // nie eksportujemy oznakowanych raportw
	endif

	if iRaportZbiorczy then
		if !EksportPN_zb_do(xRapPn.id) then
			EksportujPnDoFk = 0 // pomijamy
			Exit
		endif
	else
		if !EksportPN(xRapPn.id) then
			EksportujPnDoFk = 0 // pomijamy
			Exit
		endif
	endif

	/////////////////////////////////////////////////
	// oznaczamy wyeksportowany dokument
	if ( iOznaczaj ) then
		xRapPn = xRapPnMan.Give(using "id=%d",xRapPn.id)

		xRapPn.SetEkspFK()
	endif
EndSub

int Sub EksportujRapOkrDoFk(Dispatch xRapOkr)
	EksportujRapOkrDoFk = 1
	Dispatch xDokSp = xFactory.NewObject("BDokSp")
	Dispatch xDokumentSpPar
	Dispatch xDokumentMg
	Dispatch xDokMg

	int kk=1, ii
	int nRes
	String tak = "TAK"
	if (tak != io.GetField("__CzyPytac")) then
		nBrakSchematu = EKSP_WSZYSTKIE
		nEZatwWart = EKSP_WSZYSTKIE
		nBlednySchemat = EKSP_WSZYSTKIE
	endif

	if ( iNieEkspOznak && xRapOkr.eksportFK ) then
		EksportujRapOkrDoFk = 0 // pomijamy
		eksport.AddError("Nie mona powtrnie wyeksportowa raportu okresowego o numerze " + xRapOkr.numerDokumentu + ".")
		Exit // nie eksportujemy oznakowanych raportw
	endif

	if !EksportRapOkr(xRapOkr.id, iNieEkspOznak, iRownoKsiegMag, iDekretyZbiorcze) then
		EksportujRapOkrDoFk = 0 // pomijamy
		Exit
	endif

	/////////////////////////////////////////////////
	// oznaczamy wyeksportowany dokument
	if ( iOznaczaj ) then
		xRapOkr = xRapOkrMan.Give(using "id=%d",xRapOkr.id)

		xRapOkr.SetEkspFK()
		if ( iRownoKsiegMag ) then //oznaczanie dokumentw magazynowych powizanych z raportem okresowym dla ksigowania rwnolegego
			xKartParamsDokSp.raportOkresowyId = xRapOkr.Id
			nRes = xDokSp.Load(xKartParamsDokSp)
			
			while !nRes && kk <= xDokSp.Count()
				xDokumentSpPar=GetObjById("BDokumentSp",xDokSp.item(kk).Id)

				if ( !xDokumentSpPar.czyKorekta )then
					xDokumentSpPar.transakcjaTw.powiazaniaTw.PokazujIstniejace()
					for ii=1 to ii>xDokumentSpPar.transakcjaTw.powiazaniaTw.count
						nRes =!( xDokumentMg=GetObjById("BDokumentMg",xDokumentSpPar.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
						if nRes then  error "Dokument nie zaadowany"
				
						if (xDokumentMg.czyWystawiony) then
							nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
							if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")					

							xDokMg.SetEkspFK()
						endif
					next ii
				endif				
				for ii=1 to ii>xDokumentSpPar.zwiazkiOdpDok.Count()
					if ((xDokumentSpPar.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentSpPar.zwiazkiOdpDok.item(ii).idDk) then
						nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSpPar.zwiazkiOdpDok.item(ii).idDk))
						if nRes then  error "Dokument nie zaadowany"
						if (xDokumentMg.czyWystawiony) then
							nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
							if nRes then  PrintError("Powizany dokument magazynowy nie zaadowany")
							
							xDokMg.SetEkspFK()
						endif
					endif
				next ii

				kk=kk+1
			wend
		endif// koniec oznaczania dokumentw magazynowych powizanych z raportem okresowym dla ksigowania rwnolegego
	endif
EndSub
